/* 
$Id: cfg_pars.js 404 2010-03-30 12:42:53Z rshansen $  (Updated by svn)
*/
var do_trc = true;
var trc_parm = false;
function TRC(txt){
if(do_trc==true){
DBG(txt);
}
}
Number.prototype.intCast = function () {
var strVal = this.toString();
var strRet = ''; 
for(i = 0; (strVal.charAt(i) != '.') && i < strVal.length; i++){
strRet += strVal.charAt(i);
}
return Number(strRet);
}
String.prototype.toNCR = function () {
var strRet = '';
for (i = 0; i < this.length; i++){
if( this.charCodeAt(i) > 127) {
strRet += "&#" + this.charCodeAt(i) + ";";
}
else{
strRet += this.charAt(i);
}
}
return strRet;
}
String.prototype.trim = function () {
if(1) {
x = this.replace( /^\s+/g, ""); 
x = x.replace( /\s+$/g, ""); 
return x;
}
else{
return this.replace(/(^\s+)(\s+)$/g, "");
}
};
String.prototype.trimQuotes = function () {
if(1) {
x = this.replace( /\"/g, ""); // Remove quotes...
return x;
}
else{
return this.replace(/(^\s+)(\s+)$/g, "");
}
};
var aPages;
var cfgReader = null;
function cfgReaderObj(){
this.fso = null;
this.file = null;
}
cfgReaderObj.prototype.open = function(fdesc){
var ForReading = 1;
DBG("Opening file [" + fdesc + "]");
if( this.fso == null ){
this.fso = new ActiveXObject("Scripting.FileSystemObject");
}
if( !this.fso.FileExists(fdesc) ){
TRC("<p><b><font color='red' size='10'>File not found!</font></b><p>");
return(-1);
}
this.file = this.fso.OpenTextFile(fdesc, ForReading, false);
return 0;
}
cfgReaderObj.prototype.isEOF = function(){
if( this.fso == null ){
return false;
}
return this.file.AtEndOfStream;
}
cfgReaderObj.prototype.readln = function(){
var str;
var idx=0;
while( !this.isEOF() ){
str = this.file.ReadLine();
str = str.replace(/(^\s*|\s*$)/, "");
str = str.trim();
str = str.replace( /\/\/.*/, "" ); 
if( str.length>0 ){
return str;			
}
}	
return "";
}
cfgReaderObj.prototype.close = function(){
DBG("Closing file");
if( this.file ){
this.file.Close();
}
}
cfgReaderObj.prototype.parseOpenedFile = function (){
var rex_pageName = /"[\\\-<>=a-zA-Z0-9_/\.,: \(\)\[\]]+"/; 
var rex_pageFormater = /[a-zA-Z0-9_/. ]+/;
var rex_cfgKey = /^[a-zA-Z0-9_]+\s+/i;
var rex_cfgVal = /\s+[\(\)<>=a-zA-Z0-9_"'\.,%?\/\\:;& \-!@#\+$]+/i;
var rex_keyValPair = /[a-zA-Z0-9_]+\s+[\(\)<>=a-zA-Z0-9_"'\.,%?\/\\:;& \-!@#\+$]+\|/g;
var rex_key = rex_cfgKey;
var rex_val = rex_cfgVal;
while( !this.isEOF() ){
str = this.readln();
if( str.match(/^\[\s*Page\s+"[a-zA-Z0-9_ ]+"\s*\]/i) ) {
str = rex_pageName.exec(str); 
aPages.push( new pageObj(String(str).trimQuotes()) );
continue;
}
else if( str.match(/^\[\s*Table\s+"[a-zA-Z0-9_ /\.\(\)\[\]]+"\s*\]/i) ) {
key = "Table";
val = String(rex_pageName.exec(str)); 
aPages[aPages.length-1].addElement(key, val);
aPages[aPages.length-1].addMetaToCurrentElement("type", "Table");
aPages[aPages.length-1].addMetaToCurrentElement("headers", val);
continue;
}		
else if( str.match(/\[\s*[a-zA-Z0-9]+\s+"[<>a-zA-Z0-9/_ \\\(\)\[\]\.,:\-]+".*\]$/i) ) {
str = str.slice( str.indexOf("[")+1 ); 
key = rex_cfgKey.exec(str); 
val = rex_cfgVal.exec(str); 
key = String(key).trim();
val = String(val).trim();
aPages[aPages.length-1].addElement(key, val);	
aPages[aPages.length-1].addMetaToCurrentElement("type", key);
if( str.indexOf("|") >= 0 ){
meta = str.slice( str.indexOf("|")+1 ); 
while( (metaPair = rex_keyValPair.exec(meta)) != null ) {
var metaKey = String(rex_key.exec(metaPair));
var metaVal = rex_val.exec(metaPair);
aPages[aPages.length-1].addMetaToCurrentElement(metaKey.trim(), String(metaVal).trim() );
if( do_trc && trc_parm ) TRC("----> '" + metaKey.trim() + "' = '" + metaVal + "'");
}
}
/*			
if( key != null ){
if( String(key).indexOf("Section") >= 0){				
aPages[aPages.length-1].addMetaToCurrentElement("type", "Section" );
}
}
*/			
continue;
}
else if( str.match(/^\s*Meta\s+/i) ) {
meta = str.slice( str.indexOf("[") );
if( do_trc && trc_parm ) TRC("----> CFG, meta string '" + meta + "'");
while( (metaPair = rex_keyValPair.exec(meta)) != null ) {
var metaKey = String(rex_key.exec(metaPair));
var metaVal = rex_val.exec(metaPair);
aPages[aPages.length-1].addMetaToCurrentElement(metaKey.trim(), String(metaVal).trim() );
if( do_trc && trc_parm ) TRC("----> '" + metaKey.trim() + "' = '" + metaVal + "'");
}		
continue;
}		
if( str.match(/^[a-zA-Z0-9_]+\s+[a-zA-Z0-9_\-"';\.,: <>=$]+/i) ) {
key = String(rex_cfgKey.exec(str)).trim(); 
val = String(rex_cfgVal.exec(str)).trim(); 
if( do_trc ) {
trc_parm = false;
if( str.indexOf("INT_EC_START_DELAY") >= 0 ){			
trc_parm = true;
}
}
if( do_trc ){
if( trc_parm ) TRC("input was: " + str);
if( trc_parm ) TRC("--> '" + key + "'= '" + val + "'");
}
if( (key.length > 0 ) && (val.length > 0) ){
if( String(key).indexOf("META")<0 ){
if( updateExistingPageElement(key, val) ){
aPages[aPages.length-1].addElement(key, val);
}
}
meta = str.slice( str.indexOf("[") );
if( do_trc && trc_parm ) TRC("----> CFG, meta string '" + meta + "'");
while( (metaPair = rex_keyValPair.exec(meta)) != null ) {
var metaKey = String(rex_key.exec(metaPair));
var metaVal = rex_val.exec(metaPair);
aPages[aPages.length-1].addMetaToCurrentElement(metaKey.trim(), String(metaVal).trim() );
if( do_trc && trc_parm ) TRC("----> '" + metaKey.trim() + "' = '" + metaVal + "'");
}
}
continue;
}
if( str.match(/^\[\s*[a-zA-Z0-9_]+\s+"[a-zA-Z0-9_"';\.: ]+"\s*\]/i) ) {
key = "";
val = "";
continue;
}
if( str.match(/^\[\s*[a-zA-Z0-9_]+\s*\]/i) ) {
key = rex_pageFormater.exec(str); 
if( key.length > 0 ){
aPages[aPages.length-1].addElement(key, key);
aPages[aPages.length-1].addMetaToCurrentElement("type", "Row");
}
continue;
}
} 
}
function parse_cfg_file(f_in, f_out){
if( aPages ){
delete(aPages);
}
aPages = new Array();
if( cfgReader ){
delete(cfgReader);
}
cfgReader = new cfgReaderObj();
DBG("Opening [" + f_in + "] ...");
if( cfgReader.open(f_in) == 0){
cfgReader.parseOpenedFile();
cfgReader.close();		
}
else{
TRC("File not found: " + fname + "<br>");
return;
}
DBG("Parsing [" + f_in + "] Completed");    	
if(String(f_out).length > 0){	
DBG("Opening [" + f_out + "] ...");
if( cfgReader.open(f_out) == 0){
cfgReader.parseOpenedFile();
cfgReader.close();		
}
DBG("Parsing [" + f_out + "] Completed");    	
}
}
function save_cfg_to_file( fname ){
DBG("Saving configuration til file [" + fname + "]" );
cnt=0;
if( aPages.length == 0 ){
return 0;
}
{
var ForReading = 1;
var ForWriting = 2;
var ForAppending=8;
var allowOverwrite = true;
var disallowOverwrite = false;
var unicodeContent = true;
var asciiContent = false;
var fso;
var file;
if( fso == null ){
fso = new ActiveXObject("Scripting.FileSystemObject");
}
{
file = fso.CreateTextFile(fname, allowOverwrite, asciiContent);
}
var dObj = new Date();
file.WriteLine( "// Generated on [" + dObj + "]" );
file.WriteLine( "// ------------------------" );
for( tabIdx in aPages ){
for( itr in aPages[tabIdx].elements ){
if( aPages[tabIdx].elements[itr].isEditable == 0 ){
continue;
}
if( aPages[tabIdx].elements[itr].getMetaById("RO") ){
continue;
}
aPages[tabIdx].elements[itr].isModified = 1; 
if( aPages[tabIdx].elements[itr].isModified != 0 ){
cnt++;
txt = "";
TRC("Saving element ["+ aPages[tabIdx].elements[itr].getId() + " = " + aPages[tabIdx].elements[itr].getValue() + "]");
txt += aPages[tabIdx].elements[itr].getId() + " ";
if( aPages[tabIdx].elements[itr].isOfType("str") ){
txt += "\"" + String(aPages[tabIdx].elements[itr].getValue()).toNCR() + "\"";
}
else{
txt += aPages[tabIdx].elements[itr].getValue();
}
file.WriteLine( txt );
aPages[tabIdx].elements[itr].isModified = 0;
}
}
}
file.WriteLine( "// ------------------------" );
file.WriteLine( "// Saved "+ cnt + " parameters." );
DBG("Saved  [" + cnt + "] elements to [" + fname + "]");
file.Close();
}
return cnt;
} 
function findElementOnActPageById(elementId) {
if( aPages.length == 0 ){
return 0;
}
DBG("Active page = " + activeTabIdx );
for( n=0; n<aPages[activeTabIdx].elements.length; n++ )
{
DBG("element[" + n + "] = [" + aPages[activeTabIdx].elements[n].getId() + "]");
if( aPages[activeTabIdx].elements[n].getId().indexOf(elementId) >= 0 ){
return aPages[activeTabIdx].elements[n];
}
}
DBG("Element ["+ elementId + "] not found");
return 0;
}
function findElementById(elementId) {
if( aPages.length == 0 ){
return 0;
}
for( p=0; p<aPages.length; p++ ){
for( n=0; n<aPages[p].elements.length; n++ )
{
if( aPages[p].elements[n].getId().indexOf(elementId) >= 0 ){
return aPages[p].elements[n];
}
}
}
return 0;
}
function metaObj(id, value){
this.id = id.trim().toUpperCase();
this.value = value;
}
function pageElementObj(id, value){
this.id = String(id).trim();
this.value = String(value).trim();
this.original_value = this.value;
if( String(id).indexOf("INT")>=0 || String(id).indexOf("STR")>=0 || String(id).indexOf("BOOL")>=0 ){
this.isEditable = 1;	
}
else{
this.isEditable = 0;
}
this.isModified = 0;
this.meta = new Array();
}
pageElementObj.prototype.tagReload = function(){
this.addMeta("RELOAD", "1");
}
pageElementObj.prototype.addMeta = function(id, val){
id = id.trim();
id = id.toUpperCase();
{
for(n=0; n<this.meta.length; n++){
if( id == this.meta[n].id ){
this.meta[n].value = val;
break;
}
}
if(n>=this.meta.length ){
this.meta.push( new metaObj(id, val) );
}
}
}
pageElementObj.prototype.hide = function(){
if( this.getMetaById("hide") == "1" ){
return true;
}
return false;
}
pageElementObj.prototype.dp = function(){
if( this.getMetaById("dp") == "1" ){
return true;
}
return false;
}
pageElementObj.prototype.signed = function(){
if( this.isOfType("sint") ){
return true;
}
return false;
}
pageElementObj.prototype.reload_on_chg = function(){
if( this.getMetaById("reload") == "1" ){
return true;
}
return false;
}
pageElementObj.prototype.RO = function(){
if( this.getMetaById("RO") == "1" ){
return true;
}
return false;
}
pageElementObj.prototype.isOfType = function(type){
if( this.meta.length == 0 ){
return 0;
}
if( this.getMetaById("TYPE") == type ){
return 1;
}
return 0;
}
pageElementObj.prototype.getValue = function(){
var v = String(this.value).trim().trimQuotes(); 
if( this.isOfType("int") ){
if( this.dp() ) {
var tmp = String((v/10).intCast()) + "." + String(v%10);
return tmp;
}
}
return v;
}
pageElementObj.prototype.setValue = function( val ){
var v = Number(val);
if( this.isOfType("str") ){
return;
}
this.value = v;
}
pageElementObj.prototype.getOriginalValue = function(){
var v = String(this.original_value).trim().trimQuotes(); 
if( this.isOfType("int") ){
if( this.dp() ) {
var tmp = String((v/10).intCast()) + "." + String(v%10);
return tmp;
}
}
return v;
}
pageElementObj.prototype.getMin = function(){
var v = String(this.getMetaById("min")).trim().trimQuotes(); 
if( this.isOfType("int") ){
if( this.dp() ) {
var tmp = String((v/10).intCast()) + "." + String(v%10);
return tmp;
}
}
return v;
}
pageElementObj.prototype.getMax = function(){
var v = String(this.getMetaById("max")).trim().trimQuotes(); 
if( this.isOfType("int") ){
if( this.dp() ) {
var tmp = String((v/10).intCast()) + "." + String(v%10);
return tmp;
}
}
return v;
}
pageElementObj.prototype.getDefault = function(){
var v = String(this.getMetaById("default")).trim().trimQuotes(); 
if( this.isOfType("int") ){
if( this.dp() ) {
var tmp = String((v/10).intCast()) + "." + String(v%10);
return tmp;
}
}
return v;
}
pageElementObj.prototype.reset = function() {
d = String(this.getMetaById("default")).trim().trimQuotes();
if( this.isOfType("int") || this.isOfType("sint") || this.isOfType("list") || this.isOfType("bool") || this.isOfType("str") ){
if( this.value != d ){
this.isModified = 1; 
}
else{
this.isModified = 0; 
}    
this.value = d;
}
return this.isModified;
}
pageElementObj.prototype.revert = function(){
if( this.isOfType("int") || this.isOfType("sint") || this.isOfType("list") || this.isOfType("bool") || this.isOfType("str") ){
if( this.value != this.original_value ){
this.isModified = 1; 
}
else{
this.isModified = 0; 
}
this.value = String(this.original_value).trimQuotes();
}
return this.isModified;
}
pageElementObj.prototype.getId = function(){
return String(this.id).trim().trimQuotes();
}
pageElementObj.prototype.getMetaById = function(id){
id = id.toUpperCase();
if( this.meta.length ) { 
for( mItr in this.meta ){ 
if( this.meta[mItr].id == id ){
if( String(this.meta[mItr].value).charAt(0) == '$' ){
/** When preprended by the '$' sign, the value is interpreted as a script function 
*	reference as opposed to a real value - call into specific function to obtain value */
var mstr = String(this.meta[mItr].value);
var argidx = mstr.indexOf("("); 
var fn = mstr.slice(1, argidx);
var args = mstr.slice(argidx+1);
args = args.slice(0, args.lastIndexOf(")") );
DBG("input fn[" + fn + "], args[" + args + "]");
DBG("returned [" + fn + "]" );
return window[fn](args); 
}
else{
return String(this.meta[mItr].value).trimQuotes();
}
}
}
}
return "";
}
pageElementObj.prototype.getMaxCharLen = function(){
var maxchars = 1;
x = this.getMetaById('max');
if( x>9999 ){
maxchars = 8;
}
else if( x>999 ){
maxchars = 4;
}
else if( x>99 ){
maxchars = 3;
}	
else if( x>9 ){
maxchars = 2;
}	
if( this.dp() ){
maxchars = maxchars+1;
}	
if( this.signed() ){
maxchars = maxchars+1;
}
return maxchars;
}
function pageObj( title ){
this.title = title;
this.elements = new Array(); 
return (aPages.length);
}
pageObj.prototype.addElement = function(id, value) {
if( trc_parm ){
DBG("Adding new page element [" + id + "]" );
}
this.elements.push( new pageElementObj(id, value) );
}
pageObj.prototype.addMetaToCurrentElement = function(id, value) {
this.elements[this.elements.length-1].addMeta(id, value);
}
function updateExistingPageElement(key, val){
for( p=0; p<aPages.length; p++ ){ 
for( e=0; e<aPages[p].elements.length; e++ ){
if( aPages[p].elements[e].id.indexOf(key)>=0 ){
aPages[p].elements[e].value = val;
return 0;
}
}
}
return -1; 
}
