/* 
$Id: common.js 404 2010-03-30 12:42:53Z rshansen $  (Updated by svn)
*/
var ForReading = 1;
var ForWriting = 2;
var ForAppending=8;
var allowOverwrite = true;
var disallowOverwrite = false;
var unicodeContent = true;
var asciiContent = false;
var re_validChars = /[a-zA-Z0-9,.-;:_+*!@#&$%()=?|<>\[\]' ]/;
var re_numcheck = /[\d\r]/; 
var re_numcheck_dp = /[\d\.\r]/; 
var re_numcheck_signed = /[-\d\r]/; 
var re_numcheck_dp_signed = /[-\d\.\r]/; 
function buildStdHeader(title){
html = "";
html += "<A href='http://www.selco.com'><img src='.\\res\\img\\logo.jpg'></a><br>";
html += "<span class='heading'>" + title + "</span>";
return html;
}
function buildStdFooter(){
var dObj = new Date(); 
html = "";
html += "All rights reserved <A href='http://www.selco.com'>Selco A/S</A>. Copyright (c) 2009-" + dObj.getFullYear() + ".";
html += "<a name='end_of_page'/>";
return html;
}
function onlyDigits(e, elementId, allow_dp, allow_signed)
{
var keychar;
if(window.event){ 
if( e.keyCode == 13 ){ 
validateIntElement( elementId );
return;
}
keychar = String.fromCharCode(e.keyCode);
}
else if(e.which){ 
keychar = String.fromCharCode(e.which);	  
}
if( allow_signed ){
if( allow_dp ){
return re_numcheck_dp_signed.test(keychar);
}
else{
return re_numcheck_signed.test(keychar);  
}  
}
else{
if( allow_dp ){
return re_numcheck_dp.test(keychar);
}
else{
return re_numcheck.test(keychar);  
}
}
}
function validCharsOnly(e, elementId)
{
var keychar;
if(window.event){ 
if( e.keyCode == 13 ){ 
validateStrElement( elementId );
return;
}	
keychar = String.fromCharCode(e.keyCode);
}
else if(e.which){ 
keychar = String.fromCharCode(e.which);
}
return re_validChars.test(keychar);
}
function dump_html_element_to_file( html_id, fname ){
var fso;
var file;
if( document.getElementById(html_id) ){
fso = new ActiveXObject("Scripting.FileSystemObject");
file = fso.CreateTextFile(fname, allowOverwrite, asciiContent);
file.WriteLine(   '<?xml version="1.0" encoding="utf-8"?>');
file.WriteLine(   '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">');
file.WriteLine(   '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">');
file.WriteLine(   "<head>");
file.WriteLine(   '<meta http-equiv="content-type" content="text/html;charset=utf-8" />');
file.WriteLine(   '<meta http-equiv="Content-Style-Type" content="text/css" />');
file.WriteLine(   "<title>Selco Configuration</title>");
file.WriteLine(   "<link rel='stylesheet' type='text/css' href='res/css/selco.css'></link>");
file.WriteLine(   "</head>");
file.WriteLine(   "<body>" );
file.WriteLine(   "<div id='content_panel' class='content'>");
file.WriteLine( document.getElementById(html_id).innerHTML );
file.WriteLine(	  "    </div>");
file.WriteLine(   "</body>" );
file.WriteLine(   "</HTML>" );		
file.Close();
}
}
function if_cfg_element_is_not_equal_to_val(args){
aargs = String(args).split(","); 
eIdx = aargs[0];
val= Number(aargs[1]);    
e = findElementOnActPageById( eIdx );
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload(); 
if( Number(val)!=Number(e.getValue()) ){
return String("1");
}
}
return String("0");
}
function if_cfg_element_is_equal_to_val(args){
aargs = String(args).split(","); 
eIdx = aargs[0];
val= Number(aargs[1]);    
e = findElementById( eIdx );
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload(); 
if( Number(val)==Number(e.getValue()) ){
return String("1"); 
}
else{
return String("0"); 
}
}
return String("-1"); 
}
function if_one_or_more_cbs_are_checked(args){
aargs = String(args).split(","); 
for( argIdx in aargs ){
e = findElementOnActPageById( aargs[argIdx] );
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload(); 
if( Number(e.getValue() > 0 )){
return String("1");
}
}
}
return String("0");
}
function if_no_cbs_are_checked(args){
aargs = String(args).split(","); 
for( argIdx in aargs ){
e = findElementOnActPageById( aargs[argIdx] );
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload(); 
if( Number(e.getValue() > 0 )){
return String("0");
}
}
}
return String("1");
}
function hide_lube_interval_parms(){
if( if_cfg_element_is_equal_to_val("BOOL_SYS_LUBE_ENABLED, 0") == "1" ){
return String("1");
}
if( if_cfg_element_is_equal_to_val("INT8_SYS_LUBE_MODE, 1") == "1" ){
return String("1");
}	
return String("0");	
}
